#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
#include <math.h>
#define M_PI 3.14159265358979323846

//#include <sys/time.h>
//#include <time.h>
#include <windows.h>


#include <string.h>


struct Vertex
{
	float x;
	float y;
	float z;
};

enum Mode
{
	input,
	shooting,
	crunching,
	afterShooting,
	afterCrunching
};

enum DisplayLists
{
	START,
	
	course,
	ball,
	shadow,
	axes,
	status,
	path,

	END
};

enum TextMode
{
	output,
	setColor
};

struct ResultNode
{
	float angle;
	float length;
};

LONGLONG counts;

int width = 640;
int height = 480;

float feedbackBuffer[4];

struct Vertex cameraPos = {0.0, 0.0, 0.0};
float cameraRotY = 0.0;
float cameraRotX = 0.0;

struct Vertex holePos = {0.0, 0.0, -15.0};

struct Vertex ballSpeed = {0.0, 0.0, 0.0};
struct Vertex ballspin = {0.0, 0.0, 0.0};
struct Vertex ballPos = {0.0, 0.02, 0.0};
int airResistance = 1;

struct Vertex hitSpeed = {0.0, 5.0, -9.0};
struct Vertex hitSpin = {0.0, 0.0, 0.0};
struct Vertex hitPos = {0.0, 0.0, 0.0};
int hitResistance  = 1;

struct Vertex crunchSpeed = {0.0, 5.0, -9.0};
struct Vertex crunchSpin = {0.0, 0.0, 0.0};
struct Vertex crunchPos = {0.0, 0.0, 0.0};
int crunchResistance  = 1;

int selectedHitData = 0;

//unsigned int renderingTime = 0;
unsigned int renderingTime = 100;

char statusInfo[4][128];
unsigned int statusInfoLine = 0;

enum Mode userMode = input;

struct Vertex *pathCoords;

struct ResultNode *crunchResults;
unsigned int crunchResultsPos = 0;

/*double calculateAngle(double size, double distance)
{
	double radtheta, degtheta;
	
	radtheta = 2.0 * atan2(size/2.0, distance);
	degtheta = (180.0 * radtheta) / M_PI;
	
	return degtheta;
}*/



//Skriver ut text och kan stta frger per ANSI-frgkoder fr frgrundsfrg
void printText(char *text, int x, int y)
{
	const float defaultColor[3] = {0.8, 0.8, 0.8};
	const int rowHeight = 13;
	enum TextMode textMode = output;
	int i = 0;
	int ansiCode = 0;
	
	glColor3fv(defaultColor);
	glRasterPos2i(x, y);
	
	while(text[i] != '\0')
	{
		switch(textMode)
		{
			case output:
				switch(text[i])
				{
					case 0x27:
						textMode = setColor;
						break;
					case '\n':
						glRasterPos2i(x, y -= rowHeight);
						break;
					default:
						glutBitmapCharacter(GLUT_BITMAP_8_BY_13, text[i]);
						break;
				}
				break;
			case setColor:
				switch(text[i])
				{
					case '[':
						break;
					case 'm':
						switch(ansiCode)
						{
							case 30:
								//Svart frgrund
								glColor3f(0.0, 0.0, 0.0);
								break;
							case 31:
								//Rd frgrund
								glColor3f(1.0, 0.0, 0.0);
								break;
							case 32:
								//Grn frgrund
								glColor3f(0.0, 1.0, 0.0);
								break;
							case 33:
								//Gul frgrund
								glColor3f(1.0, 1.0, 0.0);
								break;
							case 34:
								//Bl frgrund
								glColor3f(0.0, 0.0, 1.0);
								break;
							case 35:
								//Lila frgrund
								glColor3f(1.0, 0.0, 1.0);
								break;
							case 36:
								//Cyan frgrund
								glColor3f(0.0, 1.0, 1.0);
								break;
							case 37:
								//Vit frgrund
								glColor3f(1.0, 1.0, 1.0);
								break;
							case 39:
								//Default-frgen
								glColor3fv(defaultColor);
								break;
						}
						ansiCode = 0;
						textMode = output;
						break;
					
					default:
						ansiCode = ansiCode * 10 + (text[i] - 0x30);
						break;
				}
		}		
		i++;
	}
}

void createLists(void)
{
	GLUquadric *tempQuadric;
	
		
	/******* Banan *******/
	glNewList((enum DisplayLists)course, GL_COMPILE);
	//Marken
	glColor3f(0.0, 0.5, 0.0);
	glBegin(GL_QUADS);
	//Fre hlet
	glVertex3f(-20.0, 0.0, 2.0);
	glVertex3f(-20.0, 0.0, holePos.z + 1.0);
	glVertex3f(20.0, 0.0, holePos.z + 1.0);
	glVertex3f(20.0, 0.0, 2.0);
	//Till vnster om hlet
	glVertex3f(-20.0, 0.0, holePos.z + 1.0);
	glVertex3f(-20.0, 0.0, holePos.z - 1.0);
	glVertex3f(-1.0, 0.0, holePos.z - 1.0);
	glVertex3f(-1.0, 0.0, holePos.z + 1.0);
	//Till hger om hlet
	glVertex3f(1.0, 0.0, holePos.z + 1.0);
	glVertex3f(1.0, 0.0, holePos.z - 1.0);
	glVertex3f(20.0, 0.0, holePos.z - 1.0);
	glVertex3f(20.0, 0.0, holePos.z + 1.0);
	//Efter hlet
	glVertex3f(-20.0, 0.0, holePos.z - 1.0);
	glVertex3f(-20.0, 0.0, holePos.z - 1000.0);
	glVertex3f(20.0, 0.0, holePos.z - 1000.0);
	glVertex3f(20.0, 0.0, holePos.z - 1.0);
	glEnd();
	//Greenen
	glPushMatrix();
	glColor3f(0.0, 0.52, 0.0);
	glTranslatef(0.0, 0.01, holePos.z);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	tempQuadric = gluNewQuadric();
	if(tempQuadric == 0)
		printf("Not enough memory for quadric!\n");
	gluDisk(tempQuadric, 0.054, 3.0, 64, 1);
	gluDeleteQuadric(tempQuadric);
	glPopMatrix();
	//Hlet
	glPushMatrix();
	glColor3f(0.0, 0.0, 0.0);
	glTranslatef(0.0, -0.04, holePos.z);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	tempQuadric = gluNewQuadric();
	if(tempQuadric == 0)
		printf("Not enough memory for quadric!\n");
	gluCylinder(tempQuadric, 0.054, 0.054, 0.05, 16, 1); 
	gluDeleteQuadric(tempQuadric);
	//Flaggan
	glColor3f(1.0, 1.0, 1.0);
	tempQuadric = gluNewQuadric();
	if(tempQuadric == 0)
		printf("Not enough memory for quadric!\n");
	gluCylinder(tempQuadric, 0.014, 0.01, 1.5, 8, 1); 
	gluDeleteQuadric(tempQuadric);
	glBegin(GL_TRIANGLES);
	glVertex3f(0.0, 0.0, 1.5);
	glVertex3f(0.20, 0.0, 1.4);
	glVertex3f(0.0, 0.0, 1.30);
	glEnd();
	glPopMatrix();
	glEndList();
	
	/******* Bollen *******/
	glNewList((enum DisplayLists)ball, GL_COMPILE);
	glColor3f(1.0, 1.0, 1.0);
	tempQuadric = gluNewQuadric();
	if(tempQuadric == 0)
		printf("Not enough memory for quadric!\n");
	gluSphere(tempQuadric, 0.02, 16, 16); 
	gluDeleteQuadric(tempQuadric);
	glEndList();
	
	/******* Skuggan *******/
	glNewList((enum DisplayLists)shadow, GL_COMPILE);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glColor3f(0.1, 0.1, 0.1);
	tempQuadric = gluNewQuadric();
	if(tempQuadric == 0)
		printf("Not enough memory for quadric!\n");
	gluDisk(tempQuadric, 0.0, 0.02, 16, 1);
	gluDeleteQuadric(tempQuadric);
	glEndList();
	
	/******* Hjlpaxlarna *******/
	glNewList((enum DisplayLists)axes, GL_COMPILE);
	glColor3f(0.8, 0.8, 0.8);
	glBegin(GL_LINES);
	glVertex2i(240, 30);
	glVertex2i(220, 30);
	glEnd();
	glEndList();
}


void createStatusList(void)
{
	char statusText[512];
	
	unsigned int i;
	
	sprintf(statusText, "Hit data:");
	sprintf(statusText, "%s\n Speed vector: (m/s)", statusText);
	if(selectedHitData == 0)
		sprintf(statusText, "%s%c[37m\n  x: %0.2f%c[39m",
			statusText, 0x27, hitSpeed.x, 0x27);
	else
		sprintf(statusText, "%s\n  x: %0.2f", statusText, hitSpeed.x);
	if(selectedHitData == 1)
		sprintf(statusText, "%s%c[37m\n  y: %0.2f%c[39m",
			statusText, 0x27, hitSpeed.y, 0x27);
	else
		sprintf(statusText, "%s\n  y: %0.2f", statusText, hitSpeed.y);
	if(selectedHitData == 2)
		sprintf(statusText, "%s%c[37m\n  z: %0.2f%c[39m",
			statusText, 0x27, hitSpeed.z, 0x27);
	else
		sprintf(statusText, "%s\n  z: %0.2f", statusText, hitSpeed.z);
	
	sprintf(statusText, "%s\n Spin vector: (rad/s)", statusText);
	if(selectedHitData == 3)
		sprintf(statusText, "%s%c[37m\n  x: %0.2f%c[39m",
			statusText, 0x27, hitSpin.x, 0x27);
	else
		sprintf(statusText, "%s\n  x: %0.2f", statusText, hitSpin.x);

	if(selectedHitData == 4)
		sprintf(statusText, "%s%c[37m\n  y: %0.2f%c[39m",
			statusText, 0x27, hitSpin.y, 0x27);
	else
		sprintf(statusText, "%s\n  y: %0.2f", statusText, hitSpin.y);

	if(selectedHitData == 5)
		sprintf(statusText, "%s%c[37m\n  z: %0.2f%c[39m",
			statusText, 0x27, hitSpin.z, 0x27);
	else
		sprintf(statusText, "%s\n  z: %0.2f", statusText, hitSpin.z);

	sprintf(statusText, "%s\n Air resistance:", statusText);
	if(selectedHitData == 6)
		if(hitResistance)
			sprintf(statusText, "%s%c[37m\n  enabled%c[39m", statusText, 0x27,
				0x27);
		else
			sprintf(statusText, "%s%c[37m\n  disabled%c[39m", statusText, 0x27,
				0x27);
	else
		if(hitResistance)
			sprintf(statusText, "%s\n  enabled", statusText);
		else
			sprintf(statusText, "%s\n  disabled", statusText);

	glNewList((enum DisplayLists)status, GL_COMPILE);
	printText(statusText, 10, 196);
	glBegin(GL_LINES);
	glVertex2i(10, 60);
	glVertex2i(width - 10, 60);
	glEnd();
	statusText[0] = '\0';
	for(i = 0; i < statusInfoLine; i++)
		sprintf(statusText, "%s%s\n", statusText, statusInfo[i]);
	
	printText(statusText, 10, 47);
	
	glEndList();
}



void addStatusInfo(const char *text)
{
	const unsigned int maxStatusInfoLines = 4;
	unsigned int i;
	
	
	if(statusInfoLine < maxStatusInfoLines)
	{
		strcpy(statusInfo[statusInfoLine], text);
		statusInfoLine++;
	}
	else
	{
		for(i = 0; i < (maxStatusInfoLines - 1); i++)
			strcpy(statusInfo[i], statusInfo[i + 1]);
		
		strcpy(statusInfo[maxStatusInfoLines - 1], text);
	}
	createStatusList();
	glutPostRedisplay();	
}

void defaultStatusInfo(void)
{
	statusInfoLine = 0;
	
	
	addStatusInfo("Use the arrow keys to change the parameters and hit the ball with SPACE");
	addStatusInfo("Press C to make it find the angle that gives the longest shot at 80 m/s");
	addStatusInfo("Move camera with W, S, A, D and rotate with the mouse and its first button");
	createStatusList();
	glutPostRedisplay();
}



void displayFunc(void)
{
	int glError;
	//struct timeval beforeTime;
	//struct timeval afterTime;
	//struct timezone currZone = {0, 0};
	//LONGLONG beforeTime;
	//LONGLONG afterTime;
	//LARGE_INTEGER perfVal;

	//if(gettimeofday(&beforeTime, &currZone) != 0)
		//printf("Failed to gettimeofday()\n");
	//QueryPerformanceCounter(&perfVal);
	//beforeTime = perfVal.QuadPart/counts;
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	
	//Rotera scenen
	glRotatef((cameraRotY / M_PI) * 180, 0.0, 1.0, 0.0);
	glRotatef((cameraRotX / M_PI) * 180, 1.0, 0.0, 0.0);
	//Frflytta scenen den totala frflyttning som gjorts under exekveringen
	glTranslatef(cameraPos.x, 0.0, cameraPos.z);
	//Roterar kring x-axeln s att man ser ner p planen litet
	//glRotatef(5, 1.0, 0.0, 0.0);

	//Rita banan genom att anropa dess displaylist
	glCallList((enum DisplayLists)course);
	
	glCallList((enum DisplayLists)path);
	
	//Flytta bollen och visa den genom att anropa dess displaylist
	glTranslatef(ballPos.x, ballPos.y, ballPos.z);
	glCallList((enum DisplayLists)ball);

	glRenderMode(GL_FEEDBACK);
	glBegin(GL_POINTS);
	glVertex3f(0.0, 0.0, 0.0);
	glEnd();
	glRenderMode(GL_RENDER);
	
	glDisable(GL_LIGHTING);
	glDisable(GL_DEPTH_TEST);
	glPushMatrix();
	glLoadIdentity();
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0.0, width, 0.0, height);

	glCallList((enum DisplayLists)status);

	if(feedbackBuffer[0] == GL_POINT_TOKEN)
	{
				
		glColor3f(1.0, 1.0, 1.0);
		glBegin(GL_LINE_LOOP);
		glVertex2f(feedbackBuffer[1] - 8, feedbackBuffer[2] - 8);
		glVertex2f(feedbackBuffer[1] + 8, feedbackBuffer[2] - 8);
		glVertex2f(feedbackBuffer[1] + 8, feedbackBuffer[2] + 8);
		glVertex2f(feedbackBuffer[1] - 8, feedbackBuffer[2] + 8);
		glEnd();

		feedbackBuffer[0] = 0;
		//feedbackBuffer[1] = 0;
		//feedbackBuffer[2] = 0;
	}

	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);

	//Ritar skuggan rakt under bollen
	glTranslatef(0.0, 0.01 - ballPos.y, 0.0);
	glCallList((enum DisplayLists)shadow);
	
	glPopMatrix();

	glutSwapBuffers();
	glError = glGetError();
	switch(glError)
	{
		case GL_NO_ERROR:
			break;
		case GL_INVALID_ENUM:
			printf("glError - GL_INVALID_ENUM\n");
			break;
		case GL_INVALID_VALUE:
			printf("glError - GL_INVALID_VALUE\n");
			break;
		case GL_INVALID_OPERATION:
			printf("glError - GL_INVALID_OPERATION\n");
			break;
		case GL_STACK_OVERFLOW:
			printf("glError - GL_STACK_OVERFLOW\n");
			break;
		case GL_STACK_UNDERFLOW:
			printf("glError - GL_STACK_UNDERFLOW\n");
			break;
		case GL_OUT_OF_MEMORY:
			printf("glError - GL_OUT_OF_MEMORY\n");
			break;
	}
	
	//if(gettimeofday(&afterTime, &currZone) != 0)
	//	printf("Failed to gettimeofday()\n");

	//QueryPerformanceCounter(&perfVal);
	//afterTime = perfVal.QuadPart/counts;


	//if(afterTime.tv_usec >= beforeTime.tv_usec)
	//	renderingTime = (afterTime.tv_sec - beforeTime.tv_sec) * 1000000 +
	//					(afterTime.tv_usec - beforeTime.tv_usec);
	//else
	//	renderingTime = (afterTime.tv_sec - beforeTime.tv_sec) * 1000000 -
	//					(beforeTime.tv_usec - afterTime.tv_usec);

	//renderingTime = afterTime - beforeTime;

	//printf("renderingTime: %d\n", renderingTime);
	//printf("display: %d, %d\n", width, height);
}


void reshapeFunc(int newWidth, int newHeight)
{
	width = newWidth;
	height = newHeight;
	
	if(width <= 0)
		width = 1;

	if(height <= 0)
		height = 1;

	glViewport(0, 0, width, height);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60.0, (float)width/(float)height, 1.0, 1000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0, 1.6 , 2.0 , 0 , 1.0 , 0 , 0 , 1 , 0);
	
	//createStatusList();
	
	//printf("reshape: %d, %d\n", width, height);
}

int simulateSteps(int numSteps)
{
	static int firstBounce = 1;
	static int lastOnGreen = 0;
		
	const float g = 9.82;	//Tyngdkraftsaccelerationen (N)
	const float m = 0.0045;	//Golfbollens massa (kg)
	const float p = 1.3;	//Luftens masstthet (kg/m^3)
	const float r = 0.02;	//Golfbollens radie (m)
	const float CL = 0.3;	//Luftmotstndskonstant?
	const float CM = 0.025;	//Magnuskraftskontant? (s)
	
	const float A = M_PI * (r * r); 
	
	const float KL = (1 /(2 * m)) * p * A * CL;
	const float KM = (1 /(2 * m)) * p * A * CM;
	
	const float dt = 0.0001;
	
	const struct Vertex e_V = {0.999, -0.4, 0.999};
	
	int i;
	
	char tempStr[128];
	
	struct Vertex spinCrossSpeed;

	for(i = 0; i < numSteps; i++)
	{
		//x(n + 1) = x(n) + v(n) * dt;
		ballPos.x = ballPos.x + ballSpeed.x * dt;
		ballPos.y = ballPos.y + ballSpeed.y * dt;
		ballPos.z = ballPos.z + ballSpeed.z * dt;
		
		spinCrossSpeed.x = ballspin.y * ballSpeed.z -
							ballspin.z * ballSpeed.y;

		spinCrossSpeed.y = ballspin.z * ballSpeed.x -
							ballspin.x * ballSpeed.z;

		spinCrossSpeed.z = ballspin.x * ballSpeed.y -
							ballspin.y * ballSpeed.x;

		//v(n + 1) = v(n) + (-g + -KL + KM(wxv)) * dt 
		if(airResistance)
		{
			ballSpeed.x = ballSpeed.x +
				dt * (-KL * ballSpeed.x + KM * spinCrossSpeed.x);
			ballSpeed.y = ballSpeed.y +
				dt * (-g + -KL * ballSpeed.y + KM * spinCrossSpeed.y);
			ballSpeed.z = ballSpeed.z +
				dt * (-KL * ballSpeed.z + KM * spinCrossSpeed.z);
		}
		else
		{
			ballSpeed.x = ballSpeed.x +
				dt * (KM * spinCrossSpeed.x);
			ballSpeed.y = ballSpeed.y +
				dt * (-g + KM * spinCrossSpeed.y);
			ballSpeed.z = ballSpeed.z +
				dt * (KM * spinCrossSpeed.z);		
		}
		//Kollar om det behvs studsas
		if(ballPos.y <= 0.02)
		{
			if(firstBounce)
			{
				if(userMode == crunching)
				{
					crunchResults[crunchResultsPos].length =
						sqrt((ballPos.x - hitPos.x) * (ballPos.x - hitPos.x) +
						(ballPos.z - hitPos.z) * (ballPos.z - hitPos.z));
					return 4;
				}
				else if(userMode == shooting)
				{
					sprintf(tempStr,
						"The ball travelled %0.2fm before the first bounce",
						sqrt((ballPos.x - hitPos.x) * (ballPos.x - hitPos.x) +
						(ballPos.z - hitPos.z) * (ballPos.z - hitPos.z)));
					addStatusInfo(tempStr);
					firstBounce = 0;
				}
			

			}
			
			//Studsar
			//ballSpeed.x = e_V.x * ballSpeed.x;
			ballSpeed.y = e_V.y * ballSpeed.y;
			//ballSpeed.z = e_V.z * ballSpeed.z;
		}
		
		//Kolla om bollen hamnat i hlet eller ej
		if((sqrt((holePos.x - ballPos.x)*(holePos.x - ballPos.x) +
				(holePos.z - ballPos.z)*(holePos.z - ballPos.z))
				<= (0.054 - 0.02)) && (ballPos.y < 0.03)) 
		{
			//Lta den falla ner i hlet rtt tvrt ;)
			ballPos.y = 0.0;

			firstBounce = 1;
			lastOnGreen = 0;			
			return 1;
		}
		
		if(userMode == shooting)
		{
			//Kollar om bollen kommer in p eller lmnar greenen
			if((sqrt((holePos.x - ballPos.x)*(holePos.x - ballPos.x) +
					(holePos.z - ballPos.z)*(holePos.z - ballPos.z))
					<= (3.0 - 0.02)) && (ballPos.y < 1.0))
			{
				if(!lastOnGreen)
				{
					addStatusInfo("The ball entered the green");
					lastOnGreen = 1;
				}
			}
			else
			{
				if(lastOnGreen)
				{
					addStatusInfo("The ball left the green");
					lastOnGreen = 0;
				}
			}
		}
		//Kolla om bollen rullat frdigt
		if((sqrt(ballSpeed.x * ballSpeed.x +
				ballSpeed.y * ballSpeed.y + 
				ballSpeed.z * ballSpeed.z)
				<
				(sqrt(hitSpeed.x * hitSpeed.x +
				hitSpeed.y * hitSpeed.y + 
				hitSpeed.z * hitSpeed.z) /
				100)) && (ballPos.y < 0.04))
		{
			firstBounce = 1;
			lastOnGreen = 0;			
			return 2;
		}
		
		//Kollar om bollen hamnat utanfr banan
		if(ballPos.x < - 20.0 || ballPos.x > 20.0 ||
			ballPos.y < - 0.2 ||
			ballPos.z < (holePos.z - 1000.0) || ballPos.z > 2.0)
		{
			firstBounce = 1;
			lastOnGreen = 0;			
			return 3;
		}
	}

	/*printf("ballPos - x: %f, y: %f, z: %f\n",
		ballPos.x,
		ballPos.y,
		ballPos.z);*/
	/*printf("ballSpeed - x: %f, y: %f, z: %f\n",
		ballSpeed.x,
		ballSpeed.y,
		ballSpeed.z);*/
	//Om bollen inte har hamnat i hlet eller utanfr banan eller stannat
	return 0;
}

void createPathList(void)
{
	int drawing = 1;

	ballPos.x = 0.0;
	ballPos.y = 0.02;
	ballPos.z = 0.0;
	ballSpeed = hitSpeed;
	ballspin = hitSpin;
	airResistance = hitResistance;
	glNewList((enum DisplayLists)path, GL_COMPILE);
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_LINE_STRIP);
	while(drawing)
	{
		if(simulateSteps(100) != 0)
			drawing = 0;
		else
			glVertex3f(ballPos.x, ballPos.y, ballPos.z);
	}
	glEnd();

	ballPos.x = 0.0;
	ballPos.y = 0.02;
	ballPos.z = 0.0;
	ballSpeed = hitSpeed;
	ballspin = hitSpin;
	airResistance = hitResistance;
	glColor3f(0.1, 0.1, 0.1);
	glBegin(GL_LINE_STRIP);
	drawing = 1;
	while(drawing)
	{
		if(simulateSteps(100) != 0)
			drawing = 0;
		else
			glVertex3f(ballPos.x, 0.01, ballPos.z);
	}
	glEnd();
	glEndList();
}


void timerFunc(int value)
{
	static int totalTimeSteps = 0;
	int moving = 0;
	
	//Rknar ut hur mnga tidssteg som ska stegas per bilduppdatering fr att
	//rrelserna ska bli mer eller mindre i realtid
	int timeSteps = renderingTime / 100;
	//int timeSteps = 1;
	
	timeSteps = 100;

	if(timeSteps == 0)
		timeSteps = 1;
	
	totalTimeSteps += timeSteps;

	switch(simulateSteps(timeSteps))
	{
		case 1: 
			addStatusInfo("The ball went into the hole! Press P to draw its path or R to restart");
			userMode = afterShooting;
			break;
		case 2:
			addStatusInfo("The ball stopped! Press P to draw its path or R to restart");
			userMode = afterShooting;
			break;
		case 3:

			addStatusInfo("The ball left the court! Press P to draw its path or R to restart");
			userMode = afterShooting;
			break;
		default:
			moving = 1;
			break;
	}

	glutPostRedisplay();

	if(moving)
		glutTimerFunc(timeSteps  / 10, timerFunc, 0);
	else
	{
		//Frdiga:
		//printf("Total timeSteps: %d\n", totalTimeSteps);
	}
}

void crunch(void)
{
	float angle;
	int simulating = 0;
	unsigned int i;
	
	struct ResultNode maxResult = {0.0, 0.0};
	
	char tempInfo[128];
	
	if((crunchResults = malloc(1024 * sizeof(struct ResultNode))) == 0)
	{
		printf("Could not allocate memory!\n");
		exit(1);
	}

	crunchResultsPos = 0;
	for(angle = 0.0; angle < 90.0; angle+=0.1)
	{
		crunchResults[crunchResultsPos].angle = angle;
		
		ballPos.x = 0.0;
		ballPos.y = 0.02;
		ballPos.z = 0.0;
		ballspin.x = 0.0;
		ballspin.y = 0.0;
		ballspin.z = 0.0;
		ballSpeed.x = 0.0;
		ballSpeed.y = sin((angle/180.0) * M_PI) * 80.0;
		ballSpeed.z = -cos((angle/180.0) * M_PI) * 80.0;
		crunchSpeed = ballSpeed;
		airResistance = 1;

		switch(crunchResultsPos)
		{
			case 90:
				addStatusInfo("10% done");
				displayFunc();
				break;
			case 180:
				addStatusInfo("20% done");
				displayFunc();
				break;
			case 270:
				addStatusInfo("30% done");
				displayFunc();
				break;
			case 360:
				addStatusInfo("40% done");
				displayFunc();
				break;
			case 450:
				addStatusInfo("50% done");
				displayFunc();
				break;
			case 540:
				addStatusInfo("60% done");
				displayFunc();
				break;
			case 630:
				addStatusInfo("70% done");
				displayFunc();
				break;
			case 720:
				addStatusInfo("80% done");
				displayFunc();
				break;
			case 810:
				addStatusInfo("90% done");
				displayFunc();
				break;
		}

		
		simulating = 1;
		while(simulating)
		{
			switch(simulateSteps(262144))
			{
				case 1:
				case 2:
				case 3:
					crunchResults[crunchResultsPos].length = 0.0;
					crunchResultsPos++;
					simulating = 0;
					
					break;
				case 4:
					crunchResultsPos++;
					simulating = 0;
					break;
			}
		}
		
	}
	
	ballPos.x = 0.0;
	ballPos.y = 0.02;
	ballPos.z = 0.0;
	ballspin.x = 0.0;
	ballspin.y = 0.0;
	ballspin.z = 0.0;
	ballSpeed.x = 0.0;
	ballSpeed.y = 0.0;
	ballSpeed.z = 0.0;
	
	addStatusInfo("...done");
	
	for(i = 0; i < 900; i++)
	{
		if(maxResult.length < crunchResults[i].length)
			maxResult = crunchResults[i];
	}
	free(crunchResults);
	
	sprintf(tempInfo, "Max travelled length before first bounce is %0.2f m at the angle %0.2f deg", maxResult.length, maxResult.angle);
	addStatusInfo(tempInfo);
	addStatusInfo("Data for an identical hit is now set");
	

	hitSpeed.x = 0.0;
	hitSpeed.y = sin((maxResult.angle/180.0) * M_PI) * 80.0;
	hitSpeed.z = -cos((maxResult.angle/180.0) * M_PI) * 80.0;
	hitSpin.x = 0.0;
	hitSpin.y = 0.0;
	hitSpin.z = 0.0;
	hitResistance = 1;
}

void keyboardFunc(unsigned char key, int x, int y)
{
	static int fullScreen = 0;
	static int prevWidth;
	static int prevHeight;
	static int prevPosX;
	static int prevPosY;
	
	
	switch(key)
	{
		case 0x1B:
		case 'q':
		case 'Q':
			exit(0);
		case 'f':
		case 'F':
			if(fullScreen)
			{
				glutReshapeWindow(prevWidth, prevHeight);
				glutPositionWindow(prevPosX, prevPosY);
				fullScreen = 1;
			}
			else
			{
				prevWidth = glutGet(GLUT_WINDOW_WIDTH);
				prevHeight = glutGet(GLUT_WINDOW_HEIGHT);
				prevPosX = glutGet(GLUT_WINDOW_X);
				prevPosY = glutGet(GLUT_WINDOW_Y);
				
				glutFullScreen();
				fullScreen = 0;
			}
			break;
		case ' ':
			if(userMode == input)
			{
				userMode = shooting;
				
				ballSpeed = hitSpeed;
				ballspin = hitSpin;
				hitPos = ballPos;
				airResistance = hitResistance;
				
				//Skjuter p riktigt
				glutTimerFunc(0, timerFunc, 0);
			}
			break;
		case 'b':
		case 'B':
			if(userMode == shooting)
			{
				userMode = afterShooting;
				ballSpeed.x = 0.0;
				ballSpeed.y = 0.0;
				ballSpeed.z = 0.0;
				ballspin.x = 0.0;
				ballspin.y = 0.0;
				ballspin.z = 0.0;
				ballPos.y = 0.02;
				
			}
			break;
		case 'c':
		case 'C':
			if(userMode == input)
			{
				userMode = crunching;
				addStatusInfo("Crunching...");
				displayFunc();
				crunch();
				userMode = input;
				createStatusList();
				glutPostRedisplay();
			}
			break;
		case 'g':
		case 'G':
			cameraPos.x = -ballPos.x;
			cameraPos.z = -ballPos.z;
			glutPostRedisplay();
			break;
		case 'p':
		case 'P':
			if(userMode == afterShooting)
			{
				createPathList();
				glutPostRedisplay();
			}
			break;

		case 'r':
		case 'R':
			if(userMode == afterShooting)
			{
				userMode = input;
				
				ballPos.x = 0.0;
				ballPos.y = 0.02;
				ballPos.z = 0.0;
				ballSpeed.x = 0.0;
				ballSpeed.y = 0.0;
				ballSpeed.z = 0.0;
				ballspin.x = 0.0;
				ballspin.y = 0.0;
				ballspin.z = 0.0;
				
				cameraPos.x = 0.0;
				cameraPos.z = 0.0;
				cameraRotX = 0.0;
				cameraRotY = 0.0;
				
				defaultStatusInfo();
				glDeleteLists((enum DisplayLists)path, 1);
			}
			break;
		case 's':
		case 'S':
			cameraPos.x += 0.1 * sin(cameraRotY);
			cameraPos.z -= 0.1 * cos(cameraRotY);
			glutPostRedisplay();
			break;
		case 'w':
		case 'W':
			cameraPos.x -= 0.1 * sin(cameraRotY);
			cameraPos.z += 0.1 * cos(cameraRotY);
			glutPostRedisplay();
			break;
		case 'a':
		case 'A':
			cameraPos.x -= 0.1 * sin(cameraRotY - (M_PI / 2));
			cameraPos.z += 0.1 * cos(cameraRotY - (M_PI / 2));
			glutPostRedisplay();
			break;
		case 'd':
		case 'D':
			cameraPos.x -= 0.1 * sin(cameraRotY + (M_PI / 2));
			cameraPos.z += 0.1 * cos(cameraRotY + (M_PI / 2));
			glutPostRedisplay();
			break;
	}
}

void specialFunc(int key, int x, int y)
{
	if(userMode == input)
	{
		switch(key)
		{
			case GLUT_KEY_UP:
				if(selectedHitData == 0)
					selectedHitData = 6;
				else
					selectedHitData--;
					
				createStatusList();
				glutPostRedisplay();
				break;
				
			case GLUT_KEY_DOWN:
				if(selectedHitData == 6)
					selectedHitData = 0;
				else
					selectedHitData++;
					
				createStatusList();
				glutPostRedisplay();
				break;
				
			case GLUT_KEY_LEFT:
				switch(selectedHitData)
				{
					case 0:
						hitSpeed.x -= 0.1;
						break;
					case 1:
						hitSpeed.y -= 0.1;
						break;
					case 2:
						hitSpeed.z -= 0.1;
						break;
					case 3:
						hitSpin.x -= 0.1;
						break;
					case 4:
						hitSpin.y -= 0.1;
						break;
					case 5:
						hitSpin.z -= 0.1;
						break;
					case 6:
						hitResistance = !hitResistance;
						break;
				}
				createStatusList();
				glutPostRedisplay();
				break;
				
				case GLUT_KEY_RIGHT:
				switch(selectedHitData)
				{
					case 0:
						hitSpeed.x += 0.1;
						break;
						case 1:
					hitSpeed.y += 0.1;
						break;
					case 2:
						hitSpeed.z += 0.1;
						break;
					case 3:
						hitSpin.x += 0.1;
						break;
					case 4:
						hitSpin.y += 0.1;
						break;
					case 5:
						hitSpin.z += 0.1;
						break;
					case 6:
						hitResistance = !hitResistance;
						break;
				}
				createStatusList();
				glutPostRedisplay();
				break;
		}
	}
}

int prevMouseX = -1;
int prevMouseY = -1;

void mouseFunc(int button, int state, int x, int y)
{
	switch(button)
	{
		case GLUT_LEFT_BUTTON:
			if(state == GLUT_DOWN)
				prevMouseX = x;
			else
				prevMouseX = -1;
			break;
		case GLUT_RIGHT_BUTTON:
			if(state == GLUT_DOWN)
				prevMouseY = y;
			else
				prevMouseY = -1;
			break;
	}
}

void motionFunc(int x, int y)
{

	if(prevMouseX != -1)
	{
		cameraRotY += (x - prevMouseX) * 0.01;
		prevMouseX = x;
	}
	if(prevMouseY != -1)
	{
		cameraRotX += (y - prevMouseY) * 0.01;
		prevMouseY = y;
	}
	glutPostRedisplay();
}


int main(int argc, char *argv[])
{
	//setenv("__GL_SYNC_TO_VBLANK", "1", 0);

	float position[4] = {0.0, 100.0, holePos.z / 2.0, 0};
	float ambient[4] = {0.6, 0.6, 0.6, 1.0};
	float diffuse[4] = {0.6, 0.6, 0.6, 1.0};
	float specular[4] = {0.8, 0.8,0.8, 1.0};

	//LARGE_INTEGER yo;
	
	glutInit(&argc, argv);
	glutInitWindowSize(width, height);
	glutInitWindowPosition(600, 400);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("Golf");
	glutDisplayFunc(displayFunc);
	glutReshapeFunc(reshapeFunc);
	glutKeyboardFunc(keyboardFunc);
	glutSpecialFunc(specialFunc);
	glutMouseFunc(mouseFunc);
	glutMotionFunc(motionFunc);
	
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60.0, (float)width/(float)height, 1.0, 1000.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0, 1.6 , 2.0 , 0 , 1.0 , 0 , 0 , 1 , 0);

	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	glEnable(GL_LIGHTING);	
	glClearColor(0.3, 0.3, 0.7, 0.0);	
	glFeedbackBuffer(4, GL_2D, feedbackBuffer);
		
	
	glLightfv(GL_LIGHT0, GL_POSITION, position);
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular);

	glEnable(GL_LIGHT0);
	glEnable(GL_COLOR_MATERIAL);
	
	defaultStatusInfo();
	createLists();
	createStatusList();
	
	//printf("fovy: %f\n", calculateAngle(17, 35));

	//QueryPerformanceFrequency(&yo);
	//counts = yo.QuadPart / 1000000;

	glutMainLoop();

	return 0;
}

